Index: /XIOS/dev/dev_olga/src/node/grid.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/grid.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/node/grid.cpp	(revision 1158)
@@ -31,7 +31,7 @@
       , clientDistribution_(0), isIndexSent(false) , serverDistribution_(0), clientServerMap_(0)
       , writtenDataSize_(0), numberWrittenIndexes_(0), totalNumberWrittenIndexes_(0), offsetWrittenIndexes_(0)
-      , globalDim_(), connectedDataSize_(), connectedServerRank_(), isDataDistributed_(true), isCompressible_(false)
+      , connectedDataSize_(), connectedServerRank_(), isDataDistributed_(true), isCompressible_(false)
       , transformations_(0), isTransformed_(false)
-      , axisPositionInGrid_(), positionDimensionDistributed_(1), hasDomainAxisBaseRef_(false)
+      , axisPositionInGrid_(), hasDomainAxisBaseRef_(false)
       , gridSrc_(), hasTransform_(false), isGenerated_(false), order_(), globalIndexOnServer_()
       , computedWrittenIndex_(false)
@@ -50,7 +50,7 @@
       , clientDistribution_(0), isIndexSent(false) , serverDistribution_(0), clientServerMap_(0)
       , writtenDataSize_(0), numberWrittenIndexes_(0), totalNumberWrittenIndexes_(0), offsetWrittenIndexes_(0)
-      , globalDim_(), connectedDataSize_(), connectedServerRank_(), isDataDistributed_(true), isCompressible_(false)
+      , connectedDataSize_(), connectedServerRank_(), isDataDistributed_(true), isCompressible_(false)
       , transformations_(0), isTransformed_(false)
-      , axisPositionInGrid_(), positionDimensionDistributed_(1), hasDomainAxisBaseRef_(false)
+      , axisPositionInGrid_(), hasDomainAxisBaseRef_(false)
       , gridSrc_(), hasTransform_(false), isGenerated_(false), order_(), globalIndexOnServer_()
       , computedWrittenIndex_(false)
@@ -76,7 +76,7 @@
 
 
-   StdSize CGrid::getDimension(void) const
-   {
-      return globalDim_.size();
+   StdSize CGrid::getDimension(void)
+   {
+      return getGlobalDimension().size();
    }
 
@@ -196,5 +196,5 @@
         for (int i = 0; i < axisListP.size(); ++i)
         {
-          axisListP[i]->checkAttributesOnClientAfterTransformation(globalDim_,axisPositionInGrid_[i]);
+          axisListP[i]->checkAttributesOnClientAfterTransformation(getGlobalDimension(),axisPositionInGrid_[i]);
         }
       }
@@ -243,6 +243,5 @@
      this->solveScalarRef(areAttributesChecked);
      this->solveAxisRef(areAttributesChecked);
-     this->solveDomainRef(areAttributesChecked);
-     computeGridGlobalDimension(getDomains(), getAxis(), getScalars(), axis_domain_order);
+     this->solveDomainRef(areAttributesChecked);     
      this->isDomainAxisChecked = areAttributesChecked;
    }
@@ -311,4 +310,9 @@
             {sendIndex(); this->isIndexSent = true;}
        }
+
+       // Not sure about this
+       //if (!(this->hasTransform() && !this->isTransformed()))
+       // this->isChecked = true;
+       //return;
      }
     
@@ -409,5 +413,5 @@
       using namespace std;
       std::vector<CDomain*> domainP = this->getDomains();
-      std::vector<CAxis*> axisP = this->getAxis();      
+      std::vector<CAxis*> axisP = this->getAxis();
       int dim = domainP.size() * 2 + axisP.size();
 
@@ -512,5 +516,5 @@
         {
           if (sendAtt)
-            axisListP[i]->sendCheckedAttributes(globalDim_,axisPositionInGrid_[i]);
+            axisListP[i]->sendCheckedAttributes(getGlobalDimension(),axisPositionInGrid_[i]);
           else
             axisListP[i]->checkAttributesOnClient();
@@ -534,4 +538,8 @@
         }
       }
+   }
+   std::vector<int> CGrid::getAxisPositionInGrid() const
+   {
+     return axisPositionInGrid_;
    }
 
@@ -652,6 +660,4 @@
               }              
             }
-
-
           }          
         }
@@ -695,5 +701,5 @@
        // Compute mapping between client and server
        std::vector<boost::unordered_map<size_t,std::vector<int> > > indexServerOnElement;
-       CServerDistributionDescription serverDistributionDescription(globalDim_, client->serverSize);
+       CServerDistributionDescription serverDistributionDescription(getGlobalDimension(), client->serverSize);
        serverDistributionDescription.computeServerGlobalByElement(indexServerOnElement,
                                                                   client->clientRank,
@@ -933,5 +939,5 @@
         }
       }
-     }
+    }
    }
    //----------------------------------------------------------------
@@ -1122,4 +1128,37 @@
    }
 
+/*
+   void CGrid::outputField(int rank, const CArray<double, 1>& stored, double* field)
+   {
+     const CArray<size_t,1>& out_i = outIndexFromClient[rank];
+     StdSize numElements = stored.numElements();
+     for (StdSize n = 0; n < numElements; ++n)
+     {
+       field[out_i(n)] = stored(n);
+     }
+   }
+
+   void CGrid::inputField(int rank, const double* const field, CArray<double,1>& stored)
+   {
+     const CArray<size_t,1>& out_i = outIndexFromClient[rank];
+     StdSize numElements = stored.numElements();
+     for (StdSize n = 0; n < numElements; ++n)
+     {
+       stored(n) = field[out_i(n)];
+     }
+   }
+
+   void CGrid::outputCompressedField(int rank, const CArray<double,1>& stored, double* field)
+   {
+     const CArray<size_t,1>& out_i = compressedOutIndexFromClient[rank];
+     StdSize numElements = stored.numElements();
+     for (StdSize n = 0; n < numElements; ++n)
+     {
+       field[out_i(n)] = stored(n);
+     }
+   }
+*/
+   //----------------------------------------------------------------
+
    void CGrid::storeField_arr(const double* const data, CArray<double, 1>& stored) const
    {
@@ -1170,5 +1209,4 @@
   {
     CContext* context = CContext::getCurrent();
-    // int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
     int nbSrvPools = (context->hasServer) ? (context->hasClient ? context->clientPrimServer.size() : 0) : 1;
     for (int p = 0; p < nbSrvPools; ++p)
@@ -1538,10 +1576,21 @@
   }
 
-  void CGrid::computeGridGlobalDimension(const std::vector<CDomain*>& domains,
-                                         const std::vector<CAxis*>& axis,
-                                         const std::vector<CScalar*>& scalars,
-                                         const CArray<int,1>& axisDomainOrder)
-  {
-    globalDim_.resize(domains.size()*2+axis.size()+scalars.size());
+  /*
+     Compute on the fly the global dimension of a grid with its elements
+     \param[in/out] globalDim global dimension of grid
+     \param[in] domains list of its domains
+     \param[in] axiss list of its axis
+     \param[in] scalars list of its scalars
+     \param[in] axisDomainOrder the order of element in a grid (e.g: scalar then axis)
+     \return The dimension of which we do distribution (often for server)
+  */
+  int CGrid::computeGridGlobalDimension(std::vector<int>& globalDim,
+                                        const std::vector<CDomain*> domains,
+                                        const std::vector<CAxis*> axis,
+                                        const std::vector<CScalar*> scalars,
+                                        const CArray<int,1>& axisDomainOrder)
+  {
+    globalDim.resize(domains.size()*2+axis.size()+scalars.size());
+    int positionDimensionDistributed = 1;
     int idx = 0, idxDomain = 0, idxAxis = 0, idxScalar = 0;
     for (int i = 0; i < axisDomainOrder.numElements(); ++i)
@@ -1551,13 +1600,13 @@
         if (!(domains[idxDomain]->type.isEmpty()) && (domains[idxDomain]->type==CDomain::type_attr::unstructured))
         {
-          positionDimensionDistributed_ = idx;
+          positionDimensionDistributed = idx;
         }
         else
         {
-          positionDimensionDistributed_ = idx +1;
-        }
-
-        globalDim_[idx]   = domains[idxDomain]->ni_glo.getValue();
-        globalDim_[idx+1] = domains[idxDomain]->nj_glo.getValue();
+          positionDimensionDistributed = idx +1;
+        }
+
+        globalDim[idx]   = domains[idxDomain]->ni_glo.getValue();
+        globalDim[idx+1] = domains[idxDomain]->nj_glo.getValue();
 
         ++idxDomain;
@@ -1566,5 +1615,5 @@
       else if (1 == axisDomainOrder(i))
       {
-        globalDim_[idx] = axis[idxAxis]->n_glo.getValue();
+        globalDim[idx] = axis[idxAxis]->n_glo.getValue();
         ++idxAxis;
         ++idx;
@@ -1572,14 +1621,27 @@
       else
       {
-        globalDim_[idx] = 1;
+        globalDim[idx] = 1;
         ++idxScalar;
         ++idx;
       }
     }
-  }
-
+
+    return positionDimensionDistributed;
+  }
+
+  // Retrieve the global dimension of grid
   std::vector<int> CGrid::getGlobalDimension()
   {
-    return globalDim_;
+    std::vector<int> globalDim;
+    computeGridGlobalDimension(globalDim, getDomains(), getAxis(), getScalars(), axis_domain_order);
+
+    return globalDim;
+  }
+
+  // Retrieve dimension on which we do distribution (Very often, it should be 2nd dimension)
+  int CGrid::getDistributedDimension()
+  {
+    std::vector<int> globalDim;
+    return computeGridGlobalDimension(globalDim, getDomains(), getAxis(), getScalars(), axis_domain_order);    
   }
 
Index: /XIOS/dev/dev_olga/src/node/grid.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/grid.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/node/grid.hpp	(revision 1158)
@@ -87,5 +87,5 @@
 
          /// Accesseurs ///
-         StdSize getDimension(void) const;
+         StdSize getDimension(void);
 
          StdSize  getDataSize(void) const;
@@ -176,4 +176,5 @@
          std::vector<int> getGlobalDimension();
          bool isScalarGrid() const;
+         std::vector<int> getAxisPositionInGrid() const;
 
          bool doGridHaveDataToWrite();
@@ -268,4 +269,10 @@
         void computeIndexByElement(const std::vector<boost::unordered_map<size_t,std::vector<int> > >& indexServerOnElement,
                                    CClientServerMapping::GlobalIndexMap& globalIndexOnServer);
+        int computeGridGlobalDimension(std::vector<int>& globalDim,
+                                       const std::vector<CDomain*> domains,
+                                       const std::vector<CAxis*> axis,
+                                       const std::vector<CScalar*> scalars,
+                                       const CArray<int,1>& axisDomainOrder);
+        int getDistributedDimension();
 
         void computeClientIndex();
@@ -296,6 +303,5 @@
         std::vector<int> axisPositionInGrid_;
         CGridTransformation* transformations_;
-        bool hasDomainAxisBaseRef_;
-        std::vector<int> globalDim_;
+        bool hasDomainAxisBaseRef_;        
         std::map<CGrid*, std::pair<bool,StdString> > gridSrc_;
         bool hasTransform_;
Index: /XIOS/dev/dev_olga/src/node/interpolate_domain.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/interpolate_domain.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/node/interpolate_domain.cpp	(revision 1158)
@@ -55,5 +55,5 @@
     {
       case mode_attr::read:
-        if (this->file.isEmpty())
+        if (this->weight_filename.isEmpty())
         {
           if (!this->write_weight)
@@ -64,5 +64,5 @@
         else
         {
-          weightFile = this->file;
+          weightFile = this->weight_filename;
           ifstream f(weightFile.c_str());
           if (!f.good())
@@ -75,7 +75,7 @@
         break;
       case mode_attr::read_or_compute:
-        if (!this->file.isEmpty() && !this->write_weight)
+        if (!this->weight_filename.isEmpty() && !this->write_weight)
         {
-          weightFile = this->file;
+          weightFile = this->weight_filename;
           ifstream f(weightFile.c_str());
           if (!f.good())
Index: /XIOS/dev/dev_olga/src/node/scalar.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/scalar.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/node/scalar.cpp	(revision 1158)
@@ -63,4 +63,35 @@
   {
 
+  }
+
+  /*!
+    Compare two scalar objects. 
+    They are equal if only if they have identical attributes as well as their values.
+    Moreover, they must have the same transformations.
+  \param [in] scalar Compared scalar
+  \return result of the comparison
+  */
+  bool CScalar::isEqual(CScalar* obj)
+  {
+    vector<StdString> excludedAttr;
+    excludedAttr.push_back("scalar_ref");
+    bool objEqual = SuperClass::isEqual(obj, excludedAttr);
+    if (!objEqual) return objEqual;
+
+    TransMapTypes thisTrans = this->getAllTransformations();
+    TransMapTypes objTrans  = obj->getAllTransformations();
+
+    TransMapTypes::const_iterator it, itb, ite;
+    std::vector<ETranformationType> thisTransType, objTransType;
+    for (it = thisTrans.begin(); it != thisTrans.end(); ++it)
+      thisTransType.push_back(it->first);
+    for (it = objTrans.begin(); it != objTrans.end(); ++it)
+      objTransType.push_back(it->first);
+
+    if (thisTransType.size() != objTransType.size()) return false;
+    for (int idx = 0; idx < thisTransType.size(); ++idx)
+      objEqual &= (thisTransType[idx] == objTransType[idx]);
+
+    return objEqual;
   }
 
Index: /XIOS/dev/dev_olga/src/node/scalar.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/scalar.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/node/scalar.hpp	(revision 1158)
@@ -76,10 +76,10 @@
            void duplicateTransformation(CScalar*);
            CTransformation<CScalar>* addTransformation(ETranformationType transType, const StdString& id="");
+           bool isEqual(CScalar* scalar);
 
          private:
            std::set<StdString> relFiles;
+           TransMapTypes transformationMap_;
 
-         private:
-            TransMapTypes transformationMap_;            
             void setTransformations(const TransMapTypes&);
 
Index: /XIOS/dev/dev_olga/src/node/variable.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/variable.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/node/variable.cpp	(revision 1158)
@@ -40,7 +40,22 @@
       if (!node.getContent(this->content))
       {
+        xml::THashAttributes attributes = node.getAttributes();
+        StdString variableName = attributes["name"];
+
+        node.goToParentElement();
+        StdString parentName = node.getElementName();
+        attributes = node.getAttributes();
+        error << "The variable id = " << id << " and name = " << variableName << " does not have any content. Please define it!" << std::endl
+              << "This variable is inside another element whose attributes are :" << std::endl;
+
+        for (xml::THashAttributes::iterator it = attributes.begin(); it != attributes.end(); ++it)
+        {
+           error << it->first << "=\"" << it->second.c_str() << "\" ";
+        }
+        error << std::endl; 
+
          ERROR("CVariable::parse(xml::CXMLNode & node)",
                << "[ variable id = " << id
-               << " ] variable is not defined !");
+               << " ] variable is not defined !. It does not have any content. See error log for more details.");
       }
       content = boost::trim_copy(content) ;
@@ -108,22 +123,4 @@
       }
      }
-
-    //  if (!context->hasServer)
-    //  {
-    //    CContextClient* client=context->client ;
-
-    //    CEventClient event(this->getType(),EVENT_ID_VARIABLE_VALUE) ;
-    //    if (client->isServerLeader())
-    //    {
-    //      CMessage msg ;
-    //      msg<<this->getId() ;
-    //      msg<<content ;
-    //      const std::list<int>& ranks = client->getRanksServerLeader();
-    //      for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-    //        event.push(*itRank,1,msg);
-    //      client->sendEvent(event) ;
-    //    }
-    //    else client->sendEvent(event) ;
-    // }
    }
 
Index: /XIOS/dev/dev_olga/src/node/variable.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/variable.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/node/variable.hpp	(revision 1158)
@@ -9,4 +9,5 @@
 #include "attribute_enum.hpp"
 #include "attribute_enum_impl.hpp"
+#include "declare_attribute.hpp"
 
 namespace xios
Index: /XIOS/dev/dev_olga/src/object_template.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/object_template.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/object_template.hpp	(revision 1158)
@@ -67,4 +67,7 @@
          static bool dispatchEvent(CEventServer& event) ;
 
+         bool isEqual(const string& id, const vector<StdString>& excludedAttrs);
+         bool isEqual(T* obj, const vector<StdString>& excludedAttrs);
+
          /// Accesseur statique ///
          static std::vector<boost::shared_ptr<DerivedType> > &
Index: /XIOS/dev/dev_olga/src/object_template_impl.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/object_template_impl.hpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/object_template_impl.hpp	(revision 1158)
@@ -136,4 +136,23 @@
    }
 
+   /*!
+     Compare two object of same type
+   */
+   template <class T>
+   bool CObjectTemplate<T>::isEqual(const string& id, const vector<StdString>& excludedAttrs)
+   {
+      T* obj = CObjectTemplate<T>::get(id);
+      return this->isEqual(obj, excludedAttrs);
+   }
+
+   template <class T>
+   bool CObjectTemplate<T>::isEqual(T* obj, const vector<StdString>& excludedAttrs)
+   {
+
+      CAttributeMap& attrMapThis = *this;
+      CAttributeMap& attrMapObj  = *obj;
+      return (attrMapThis.isEqual(attrMapObj, excludedAttrs));
+   }
+
    //---------------------------------------------------------------
 
@@ -199,31 +218,4 @@
          }
        }
-
-     // if (client->isServerLeader())
-     // {
-     //   size_t minimumSize = 0;
-     //   CAttributeMap& attrMap = *this;
-     //   CAttributeMap::const_iterator it = attrMap.begin(), itE = attrMap.end();
-     //   for (; it != itE; ++it)
-     //   {
-     //     if (!it->second->isEmpty())
-     //     {
-     //       size_t size = it->second->getName().size() + sizeof(size_t) + it->second->size();
-     //       if (size > minimumSize)
-     //         minimumSize = size;
-     //     }
-     //   }
-
-     //   if (minimumSize)
-     //   {
-     //     // Account for extra header info
-     //     minimumSize += CEventClient::headerSize + getIdServer().size() + sizeof(size_t);
-
-     //     const std::list<int>& ranks = client->getRanksServerLeader();
-     //     for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-     //       minimumSizes.insert(std::make_pair(*itRank, minimumSize));
-     //   }
-     // }
-
        return minimumSizes;
      }
@@ -257,6 +249,5 @@
       CAttributeMap & attrMap = *this;
       CAttribute* attr=attrMap[id];
-      if (attr->doSend()) 
-        sendAttributToServer(*attr);
+      sendAttributToServer(*attr);
    }
 
@@ -369,5 +360,4 @@
   }
 
-
   template <class T>
   void CObjectTemplate<T>::recvAttributFromClient(CEventServer& event)
Index: /XIOS/dev/dev_olga/src/parse_expr/filter_expr_node.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/parse_expr/filter_expr_node.cpp	(revision 1157)
+++ /XIOS/dev/dev_olga/src/parse_expr/filter_expr_node.cpp	(revision 1158)
@@ -2,4 +2,5 @@
 #include "unary_arithmetic_filter.hpp"
 #include "binary_arithmetic_filter.hpp"
+#include "ternary_arithmetic_filter.hpp"
 #include "field.hpp"
 
@@ -40,15 +41,24 @@
   boost::shared_ptr<COutputPin> CFilterTemporalFieldExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
   {
-    if (!CField::has(fieldId))
+    boost::shared_ptr<COutputPin> outputPin;
+
+    if (fieldId == "this")
+      outputPin = thisField.getSelfTemporalDataFilter(gc, thisField.freq_op.isEmpty() ? TimeStep : thisField.freq_op);
+    else if (CField::has(fieldId))
+    {
+      CField* field = CField::get(fieldId);
+      if (field == &thisField)
+        ERROR("boost::shared_ptr<COutputPin> CFilterTemporalFieldExprNode::reduce(CGarbageCollector& gc, CField& thisField) const",
+              << "The field " << fieldId << " has an invalid reference to itself. "
+              << "Use the keyword \"this\" if you want to reference the input data sent to this field.");
+
+      field->buildFilterGraph(gc, false);
+      outputPin = field->getTemporalDataFilter(gc, thisField.freq_op.isEmpty() ? TimeStep : thisField.freq_op);
+    }
+    else
       ERROR("boost::shared_ptr<COutputPin> CFilterTemporalFieldExprNode::reduce(CGarbageCollector& gc, CField& thisField) const",
             << "The field " << fieldId << " does not exist.");
 
-    CField* field = CField::get(fieldId);
-    if (field == &thisField)
-      ERROR("boost::shared_ptr<COutputPin> CFilterFieldExprNode::reduce(CGarbageCollector& gc, CField& thisField) const",
-            << "The field " << fieldId << " has an invalid reference to itself.");
-
-    field->buildFilterGraph(gc, false);
-    return field->getTemporalDataFilter(gc, thisField.freq_op.isEmpty() ? TimeStep : thisField.freq_op);
+    return outputPin;
   }
 
@@ -120,3 +130,147 @@
     return filter;
   }
+
+
+
+
+  CFilterScalarScalarFieldOpExprNode::CFilterScalarScalarFieldOpExprNode(IScalarExprNode* child1, const std::string& opId, IScalarExprNode* child2, IFilterExprNode* child3)
+    : child1(child1)
+    , opId(opId)
+    , child2(child2)
+    , child3(child3)
+  {
+    if (!child1 || !child2 || !child3)
+      ERROR("  CFilterScalarScalarFieldOpExprNode::CFilterScalarScalarFieldOpExprNode(IScalarExprNode* child1, const std::string& opId, IScalarExprNode* child2, IFilterExprNode* child3)",
+            "Impossible to create the new expression node, an invalid child node was provided.");
+  }
+
+  boost::shared_ptr<COutputPin> CFilterScalarScalarFieldOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
+  {
+    boost::shared_ptr<CScalarScalarFieldArithmeticFilter> filter(new CScalarScalarFieldArithmeticFilter(gc, opId, child1->reduce(),child2->reduce()));
+    child3->reduce(gc, thisField)->connectOutput(filter, 0);
+    return filter;
+  }
+
+
+  CFilterScalarFieldScalarOpExprNode::CFilterScalarFieldScalarOpExprNode(IScalarExprNode* child1, const std::string& opId, IFilterExprNode* child2, IScalarExprNode* child3)
+    : child1(child1)
+    , opId(opId)
+    , child2(child2)
+    , child3(child3)
+  {
+    if (!child1 || !child2 || !child3)
+      ERROR("  CFilterScalarFieldScalarOpExprNode::CFilterScalarFieldScalarOpExprNode(IScalarExprNode* child1, const std::string& opId, IFilterExprNode* child2, IScalarExprNode* child3)",
+            "Impossible to create the new expression node, an invalid child node was provided.");
+  }
+
+  boost::shared_ptr<COutputPin> CFilterScalarFieldScalarOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
+  {
+    boost::shared_ptr<CScalarFieldScalarArithmeticFilter> filter(new CScalarFieldScalarArithmeticFilter(gc, opId, child1->reduce(),child3->reduce()));
+    child2->reduce(gc, thisField)->connectOutput(filter, 0);
+    return filter;
+  }
+
+
+  CFilterScalarFieldFieldOpExprNode::CFilterScalarFieldFieldOpExprNode(IScalarExprNode* child1, const std::string& opId, IFilterExprNode* child2, IFilterExprNode* child3)
+    : child1(child1)
+    , opId(opId)
+    , child2(child2)
+    , child3(child3)
+  {
+    if (!child1 || !child2 || !child3)
+      ERROR("  CFilterScalarFieldFieldOpExprNode::CFilterScalarFieldFieldOpExprNode(IScalarExprNode* child1, const std::string& opId, IFilterExprNode* child2, IFilterExprNode* child3)",
+            "Impossible to create the new expression node, an invalid child node was provided.");
+  }
+
+  boost::shared_ptr<COutputPin> CFilterScalarFieldFieldOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
+  {
+    boost::shared_ptr<CScalarFieldFieldArithmeticFilter> filter(new CScalarFieldFieldArithmeticFilter(gc, opId, child1->reduce()));
+    child2->reduce(gc, thisField)->connectOutput(filter, 0);
+    child3->reduce(gc, thisField)->connectOutput(filter, 1);
+    return filter;
+  }
+
+
+
+  CFilterFieldScalarScalarOpExprNode::CFilterFieldScalarScalarOpExprNode(IFilterExprNode* child1, const std::string& opId, IScalarExprNode* child2, IScalarExprNode* child3)
+    : child1(child1)
+    , opId(opId)
+    , child2(child2)
+    , child3(child3)
+  {
+    if (!child1 || !child2 || !child3)
+      ERROR("  CFilterFieldScalarScalarOpExprNode::CFilterFieldScalarScalarOpExprNode(IFilterExprNode* child1, const std::string& opId, IScalarExprNode* child2, IScalarExprNode* child3)",
+            "Impossible to create the new expression node, an invalid child node was provided.");
+  }
+
+  boost::shared_ptr<COutputPin> CFilterFieldScalarScalarOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
+  {
+    boost::shared_ptr<CFieldScalarScalarArithmeticFilter> filter(new CFieldScalarScalarArithmeticFilter(gc, opId, child2->reduce(),child3->reduce()));
+    child1->reduce(gc, thisField)->connectOutput(filter, 0);
+    return filter;
+  }
+
+
+
+  CFilterFieldScalarFieldOpExprNode::CFilterFieldScalarFieldOpExprNode(IFilterExprNode* child1, const std::string& opId, IScalarExprNode* child2, IFilterExprNode* child3)
+    : child1(child1)
+    , opId(opId)
+    , child2(child2)
+    , child3(child3)
+  {
+    if (!child1 || !child2 || !child3)
+      ERROR("  CFilterFieldScalarFieldOpExprNode::CFilterFieldScalarFieldOpExprNode(IFilterExprNode* child1, const std::string& opId, IScalarExprNode* child2, IFilterExprNode* child3)",
+            "Impossible to create the new expression node, an invalid child node was provided.");
+  }
+
+  boost::shared_ptr<COutputPin> CFilterFieldScalarFieldOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
+  {
+    boost::shared_ptr<CFieldScalarFieldArithmeticFilter> filter(new CFieldScalarFieldArithmeticFilter(gc, opId, child2->reduce()));
+    child1->reduce(gc, thisField)->connectOutput(filter, 0);
+    child3->reduce(gc, thisField)->connectOutput(filter, 1);
+    return filter;
+  }
+
+
+
+  CFilterFieldFieldScalarOpExprNode::CFilterFieldFieldScalarOpExprNode(IFilterExprNode* child1, const std::string& opId, IFilterExprNode* child2, IScalarExprNode* child3)
+    : child1(child1)
+    , opId(opId)
+    , child2(child2)
+    , child3(child3)
+  {
+    if (!child1 || !child2 || !child3)
+      ERROR("  CFilterFieldFieldScalarOpExprNode::CFilterFieldFieldScalarOpExprNode(IFilterExprNode* child1, const std::string& opId, IFilterExprNode* child2, IScalarExprNode* child3)",
+            "Impossible to create the new expression node, an invalid child node was provided.");
+  }
+
+  boost::shared_ptr<COutputPin> CFilterFieldFieldScalarOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
+  {
+    boost::shared_ptr<CFieldFieldScalarArithmeticFilter> filter(new CFieldFieldScalarArithmeticFilter(gc, opId, child3->reduce()));
+    child1->reduce(gc, thisField)->connectOutput(filter, 0);
+    child2->reduce(gc, thisField)->connectOutput(filter, 1);
+    return filter;
+  }
+
+
+  CFilterFieldFieldFieldOpExprNode::CFilterFieldFieldFieldOpExprNode(IFilterExprNode* child1, const std::string& opId, IFilterExprNode* child2, IFilterExprNode* child3)
+    : child1(child1)
+    , opId(opId)
+    , child2(child2)
+    , child3(child3)
+  {
+    if (!child1 || !child2 || !child3)
+      ERROR("  CFilterFieldFieldFieldOpExprNode::CFilterFieldFieldFieldOpExprNode(IFilterExprNode* child1, const std::string& opId, IFilterExprNode* child2, IFilterExprNode* child3)",
+            "Impossible to create the new expression node, an invalid child node was provided.");
+  }
+
+  boost::shared_ptr<COutputPin> CFilterFieldFieldFieldOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
+  {
+    boost::shared_ptr<CFieldFieldFieldArithmeticFilter> filter(new CFieldFieldFieldArithmeticFilter(gc, opId));
+    child1->reduce(gc, thisField)->connectOutput(filter, 0);
+    child2->reduce(gc, thisField)->connectOutput(filter, 1);
+    child3->reduce(gc, thisField)->connectOutput(filter, 2);
+    return filter;
+  }
+  
 }
